#!/usr/bin/perl


# Copyright 2003 The Board of Trustees of 
# The Leland Stanford Junior University. All Rights Reserved.

# Communication to Jessica Shapiro, jessicas@stanford.edu

use strict vars;

my($pdbdir);
my($dsspdir);

$pdbdir = shift(@ARGV);
$dsspdir = shift(@ARGV);

my(@pdbsubdirs);
my(@pdbfiles);
my($pdbfile);
my($pdbid);
my($dsspfile);
my($dsspprog) = "/usr/local/bin/dssp";
my($gzip) = "/bin/gzip";
my($mkdir) = "/bin/mkdir";
my($zcat) = "/bin/zcat";
my($rm) = "/bin/rm";
my($subdir,$pdbsubdir);

#make the directory for the dssp files
if(! -e($dsspdir)) {
  `$mkdir $dsspdir`;
}

#read in all subdirectories of the pdb database
opendir(PDBDIR, $pdbdir) || die "can't open PDB directory ($pdbdir): $!\n";
@pdbsubdirs = grep(/^[A-Za-z0-9][A-Za-z0-9]$/,readdir(PDBDIR));
closedir(PDBDIR);

foreach $subdir (@pdbsubdirs) {
  if(! -e("$dsspdir/$subdir")) {
    `$mkdir $dsspdir/$subdir`;
  }
  opendir(DIR,"$pdbdir/$subdir") || die "can't open $pdbdir/$subdir for reading: $!\n";
  @pdbfiles = grep(!/^\.\.?$/,readdir(DIR));
  closedir(PDBDIR);
  
  foreach $pdbfile (@pdbfiles) {
    $pdbid = $pdbfile;
    if($pdbfile =~ /^(.*)\.(.*)$/) { #strip off any filename extensions
      $pdbid = $1;
    }
    `$zcat -f $pdbdir/$subdir/$pdbfile > /tmp/temp.pdb`;
    $dsspfile = "$pdbid".".dssp";
    `$dsspprog -na /tmp/temp.pdb $dsspdir/$subdir/$dsspfile > /dev/null`;
    `$gzip $dsspdir/$subdir/$dsspfile`;
  }
}
`$rm /tmp/temp.pdb`;

