#!/usr/bin/perl -T

# Copyright 2003 The Board of Trustees of 
# The Leland Stanford Junior University. All Rights Reserved.

# Communication to Jessica Shapiro (jessicas@stanford.edu)


use CGI;

$q = new CGI;
$pdbfile = $q->param('pdbname');
$outputdir = $q->param('resultsdir'); #need to pass this and next arg in!
$wwwoutput = $q->param('wwwdir');
if(!defined($pdbfile)) {
  $pdbfile = shift(@ARGV);
}

#make sure pdbfile argument is reasonable (security check)
if(length($pdbfile)==7) { #scop id
  $pdbfile = securityCheckProteinName($pdbfile,1)
}elsif(length($pdbfile)==4 || length($pdbfile)==6) { #pdb id, with or without chain
  $pdbfile = securityCheckProteinName($pdbfile,0);
}elsif($pdbfile =~ /^(queryfile)$/) {
  $pdbfile = $1;
}
if($pdbfile eq "") {
  redirectToErrorHandler("","A variable (pdbname) has an unexpected value.","","","");
  exit(-1);
}

#check syntax of outputdir
if($outputdir =~m|^(/var/www/html/FoldMiner2/results/[0-9]+$)|) {
  $outputdir = $1;
  my($id) = $2;
}else {
  redirectToErrorHandler("","A variable (outdir) has an unexpected value. This value is normally set in a cgi script and should not be altered","","",$id);    
  exit(-1);
}

#check the syntax of wwwoutput
   if($wwwoutput =~ m|^(/FoldMiner2/results/[0-9]+)$|) {
     $wwwoutput = $1;
   }else {
     redirectToErrorHandler("","A variable (wwwdir) has an unexpected value. This value is normally set in a cgi script and should not be altered","","",$id);    
     exit(-1);
   }


$PDBPATH = "/usr/db/pdb";
$file = "/usr/bin/file";
$cat = "/bin/cat";
$ln = "/bin/ln";
$gunzip = "/bin/gunzip";
#$uncompress = "@UNCOMPRESS@";
$rm = "/bin/rm";
$mkdir = "/bin/mkdir";


findfile($pdbfile, "$outputdir/$pdbfile.pdb");

printHeader();

if (-e "$outputdir/$pdbfile.pdb") { #if found pdbfile

    open(Tfile, "<$outputdir/$pdbfile.pdb");

    $done = 0;
    print "<b>Found PDB structure: $pdbfile</b><br>\n";   
    print "<p><b>Get full text file <a href=$wwwoutput/$pdbfile.pdb target=_top>$pdbfile.pdb</a> or ";
    print "<a href=\"/cgi-bin/FoldMiner2/chime.cgi?myfile=$wwwoutput/$pdbfile.pdb\">view in Chime</a></b><br><br>\n";

    print "<hr>\n";

    print "<pre>\n";
    while (($line = <Tfile>) && ($done < 50)) {

	print "$line";
	$done = $done + 1;
    }
    print "</pre><br><br>\n";

    close(Tfile);


}

else {
    print "Sorry.  Could not find PDB structure: $pdbfile<br>\n";
}
    

print "</body></html>\n";

exit(0);

######################################################################

sub printHeader() {

print <<END;
Server: Apache/1.3.27 (Unix)  (Red-Hat/Linux)
MIME-version: 1.0
Content-type: text/html


<meta http-equiv=description name=description 
content="LOCK 2, output">
<meta http-equiv=keywords name=keywords 
content="hierarchical protein structure superposition, bioinformatics, LOCK, biochemistry">

<title>LOCK 2 Results: Done</title>
</head>

<body bgcolor=#FFFFFF link=#26246b alink=#8777bab vlink=#8777bab>

<p>
<table width=100% cellpadding=0 cellspacing=0 border=0>

<tr><td align=left><a href=/FoldMiner2/?lock target=_top><img align=left src=/FoldMiner2/images/lock2.gif border=0></a></td>

<td align=right>
<br><a href="mailto:jessicas\@stanford.edu" >Jessica Shapiro</a>
<br><a href=http://gene.stanford.edu/~apsingh target=_top>Amit P. Singh</a>
<br><a href=//cmgm.stanford.edu/~brutlag target=_top>Douglas L. Brutlag</a>
<br><a href=http://motif.stanford.edu target=_top>Bioinformatics Group</a>
<br><a href=//www.stanford.edu/ target=_top>Stanford University</a>
</td>
</tr>
</table></p>

<br>
END
}


sub findfile() {

    $longpdbname = $_[0];
    $newname = $_[1];

    if($newname !~ /queryfile|targetfile\.pdb$/) {
      if (-e $newname) {
	system($rm, $newname);
      }
    }

    ($pdbname) = $longpdbname =~ /^(....)/;
    
    $pdbname =~ tr/A-Z/a-z/;
        
    $myfile = findFile($pdbname);
    if ($myfile ne "NOFILE") {
	
      open(OLD_STDOUT, ">&STDOUT");
      open(STDOUT, ">/tmp/$$\.file");
      select(STDOUT); $|=1;
      system($file, $myfile);
      close(SDTOUT);
      open(STDOUT, ">&OLD_STDOUT");
      open(IN, "/tmp/$$\.file");
      $temp = <IN>;
      close(IN);
      @ftype = split /\s+/, $temp;
      system($rm,"-f","/tmp/$$\.file");

      if ($ftype[1] eq "gzip") {	
	open(OLD_STDOUT, ">&STDOUT");
	open(STDOUT,">$newname.gz") || die "can't open new stdout (/tmp/$newname.gz): $!\n";
	select(STDOUT); $| = 1;
	system($cat, $myfile);
	close(STDOUT);
	open(STDOUT, ">&OLD_STDOUT");
	system($gunzip, "$newname\.gz");
      }
      elsif ($ftype[1] eq "compressed") {	
	open(OLD_STDOUT, ">&STDOUT");
	open(STDOUT,">$newname.Z");
	select(STDOUT); $| = 1;
	system($cat, $myfile);
	close(STDOUT);
	open(STDOUT, ">&OLD_STDOUT");
	system($gunzip,"$newname.Z");
      }
      else {
	system($ln,"-s",$myfile,$newname);
	}
    }
}

sub findFile() {

    ($two_letter) = $_[0] =~ /^[0-9](..)/;
    $mytemp = getFile("$PDBPATH/$two_letter/$_[0].pdb");
    if ($mytemp eq "NOFILE") {
	$mytemp = getFile("$PDBPATH/$_[0].pdb");
    }
    if ($mytemp eq "NOFILE") {
	$mytemp = getFile("$PDBPATH/pdb$_[0].ent");
    }
    if($mytemp eq "NOFILE") {
	$mytemp = getFile("$PDBPATH/pdb$_[0].ent");
    }
    if($mytemp eq "NOFILE") {
	$mytemp = getFile("$PDBPATH/$two_letter/pdb$_[0].ent");
    }
    
    return $mytemp;
}


sub getFile() {

    $mytemp = $_[0];

    if (-e $mytemp) {
	return $mytemp;
    }

    $mytemp = "$_[0]".".gz";
    if (-e $mytemp) {
	return $mytemp;
    }

    $mytemp = "$_[0]".".Z";
    if (-e $mytemp) {
	return $mytemp;
    }

    return "NOFILE";

}
    
sub securityCheckProteinName {
  my($inputname, $isScop) = @_;
  my($cleanname,$pdbid);
  
  $cleanname = "";
  if($isScop) {
    $inputname =~ /^([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])/;
    $cleanname = $1;
  }else {
    if($inputname =~ /^(queryfile)$/) { #from file upload
      $cleanname = $1;
    }else {
      $inputname =~/^([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?/;
      $cleanname = $1.$2; #$1 is the pdb id, and $2 is the chain, prefixed by '-'
    }
  }
  return $cleanname; #need to do error checking -- could return empty string
}

sub redirectToErrorHandler {
  my($input,$error,$correctinput,$helptopic,$pid) = @_;
  my($email) = "jessicas\@stanford.edu";
  my($name) = "Jessica Ebert";

  $input=CGI::escape($input);
  $error = CGI::escape($error);
  $correctinput=CGI::escape($correctinput);
  $helptopic=CGI::escape($helptopic);
  $email=CGI::escape($email);
  $name=CGI::escape($name);


  print "Cache-control: no-cache\n";
  print "Content-type: text/html\n\n";
  print <<END;
<html>
<head>
<meta http-equiv="Pragma" content='no-cache'>
<meta http-equiv="refresh" content="0;URL=/cgi-bin/FoldMiner2/reporterror.cgi?error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsidr=$pid">
<title>LOCK 2: Error</title>
</head>
<body>
An error occurred. If you are not automatically redirected in two seconds, <a href="/cgi-bin/FoldMiner2/reporterror.cgi?error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsdir=$pid">click here.</a>
</body>
</html>
END

}
