#!/usr/bin/perl -T 
# Copyright 1997 The Board of Trustees of 
# The Leland Stanford Junior University. All Rights Reserved.

# Communication to Jessica Shapiro, jessicas@stanford.edu

use CGI;
$ENV{'PATH'} = "/bin:/usr/bin:/usr/local/bin";


$PDBPATH = "/usr/db/scop-1.63-pdb";
$file = "/usr/bin/file";
$cat = "/bin/cat";
$ln = "/bin/ln";
$gunzip = "/bin/gunzip";
#$uncompress = "@UNCOMPRESS@";
$rm = "/bin/rm";

%aacodes = (A => "ALA", R=>"ARG", N=>"ASN", D=>"ASP", B=>"ASX",C=>"CYS",Q=>"GLN",E=>"GLU",Z=>"GLX",G=>"GLY",H=>"HIS",I=>"ILE",L=>"LEU",K=>"LYS",M=>"MET",F=>"PHE",P=>"PRO",S=>"SER",T=>"THR",W=>"TRP",Y=>"TYR",V=>"VAL");


$q = new CGI;
$outputdir = $q->param('outdir');
$wwwoutput = $q->param('wwwdir');
$mainfile = $q->param('yourfile');
$chime = $q->param('chime');

if($chime =~ /^1$/) {
  $filenum = $q->param('filenum');
}

$score = $q->param('score');
$pvalue = $q->param('pval');
$num_aligned_SSEs=$q->param('alignedSSEs');
$num_aligned_residues=$q->param('alignedresidues');
$rmsd = $q->param('rmsd');
$description = $q->param('description');
$motif = $q->param('motif'); #if 1, this was a structural similarity search and query's motif is known

if(!defined($motif)) {
  $motif = 0;
}
#check the syntax of outputdir
if($outputdir =~m|^(/var/www/html/FoldMiner2/results/)([0-9]+$)|) {
  $outputdir = $1.$2;
  my($id) = $2;
}else {
  redirectToErrorHandler("","A variable (outdir) has an unexpected value. This value is normally set in a cgi script and should not be altered","","",$id);      exit(-1);
}
   
   #check the syntax of wwwoutput
   if($wwwoutput =~ m|^(/FoldMiner2/results/[0-9]+)$|) {
     $wwwoutput = $1;
   }else {
     redirectToErrorHandler("","A variable (wwwdir) has an unexpected value. This value is normally set in a cgi script and should not be altered","","",$id);    
     exit(-1);
   }

#check the syntax of mainfile
    if($mainfile =~ m|^([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9]_[dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])(\.out)$|) { #scop id, scop id
     $mainfile=$1.$2;
     $outfile = $1."\.pdb";
   }elsif($mainfile =~ m|^([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(_)([dg][0-9][A-Za-z0-9]{3})([\._A-Za-z0-9][_0-9])\.out$|) { #pdb id, scop id
     $mainfile = $&; #the entire matched string
     $outfile = $mainfile;
     $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~ m|^([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(_)([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(\.out)$|) { #pdb id, pdb id
     $mainfile = $&;
     $outfile = $mainfile;
     $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~ m|^([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])(_)([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(\.out)$|) { #scop id, pdbid
     $mainfile = $&;
     $outfile = $mainfile;
     $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~ /^(query_target\.out)$/) {
     $mainfile = $1;
     $outfile = $mainfile;
     $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~ /^([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(_target\.out)$/) {
     $mainfile = $&; $outfile = $mainfile; $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~/^(query_)([0-9][A-Za-z0-9]{3})(-[A-Za-z0-9])?(\.out)$/) {
     $mainfile = $&; $outfile = $mainfile; $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~/^([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])(_target\.out)$/) {
     $mainfile = $&; $outfile = $mainfile; $outfile =~ s/out$/pdb/;
   }elsif($mainfile =~/^(query_)([dg][0-9][A-Za-z0-9]{3}[\._A-Za-z0-9][_0-9])(\.out)$/) {
     $mainfile = $&; $outfile = $mainfile; $outfile =~ s/out$/pdb/;
   }else {
#     print "problem with mainfile ($mainfile)\n";
     redirectToErrorHandler($mainfile,"The name of the file containing the LOCK 2 alignment contains unexpected characters. This value is normally set in a cgi script and should not be altered","","",$id);    
     exit(-1);
   }

#check the syntax of chime parameter
   if($chime =~/^([01])$/) {
     $chime = $1;
   }else {
     redirectToErrorHandler("","A variable (chime) has an unexpected value. This value is normally set in a cgi script and should not be altered","","",$id);    
     exit(-1);
   }

   open(MAINFILE, "<$outputdir/$mainfile") || die "can't open $outputdir/$mainfile: $!\n";
   while ($line = <MAINFILE>) {
     chop($line);
     @fields = split /\s+/, $line;
     
     if ($fields[0] eq "Query:") {
       $queryfile = $fields[1];
       
       chomp($queryfile);
       if($queryfile =~ m|/|) {
	 if($queryfile =~ m|^(/?(([\w\-\.])*/){1,}([\w\-\.]+))$|) {
	   $queryfile = $1;
	   $shortqueryname = $+; #$+ returns the last matched bracket
	 }else {
	   redirectToErrorHandler($queryfile,"The name of the query structure file has an unexpected value. This error should not occur if you have submitted all of your requests via the FoldMiner web pages.","","",$id);    
	   exit(-1);
	 }
       }elsif($queryfile =~ m|^([\w\-\.]+)$|) {
	 $shortqueryname = $+;
	 $queryfile = $1;
       }else {
	 redirectToErrorHandler($queryfile,"The name of the query structure file has an unexpected value. This error should not occur if you have submitted all of your requests via the FoldMiner web pages.","","",$id);    
	 exit(-1);
       }
       
       if($shortqueryname =~ /^(.*)(\..*)?/) {
	 if(length($1) == 7) { #using scop id
	   $queryIsScop = 1;
	   ($querypdbid)  = $shortqueryname =~ /^.(....)..$/;
	   
	   if($queryfile =~ /scop\-[0-9]\.[0-9]*\-dssp/) {
	     $queryfile =~ s/(scop\-[0-9]\.[0-9]*\-)dssp/$1pdb/;
	     $queryfile .= ".ent";
	   }
	 }else {
	   $queryIsScop = 0;
	   ($querypdbid) = $shortqueryname;
	 }
       }
       
     }
  if ($fields[0] eq "Target:") {
    $targetfile = $fields[1];
    if($targetfile =~ m|^/|) {
      if($targetfile =~ m|^(/?(([\w\-\.])*/){1,}([\w\-\.]+))$|) {
	$targetfile = $1;
	$shorttargetname = $+; #$+ returns the last matched bracket
      }else {
	redirectToErrorHandler($targetfile,"The name of the query structure file has an unexpected value. This error should not occur if you have submitted all of your requests via the FoldMiner web pages.","","",$id);    
      }
    }elsif ($targetfile =~ m|^([\w\-\.]+)$|) {
      $shorttargetname = $+; 
      $targetfile = $1;
    }else {
      redirectToErrorHandler($targetfile,"The name of the query structure file has an unexpected value. This error should not occur if you have submitted all of your requests via the FoldMiner web pages.","","",$id);    
      exit(-1);
    }
    if($shorttargetname =~ /^(.*)(\..*)?/) {
      if(length($1) == 7) { #using scop id
	$targetIsScop = 1;
	($targetpdbid)  = $shorttargetname =~ /^.(....)..$/;
      }else {
	$targetIsScop = 0;
	$targetpdbid = $shorttargetname;
      }
    }
    
  }

  if (($fields[0] eq "Transformation") && ($fields[3] eq "query")) {
      
      for ($i = 0; $i < 4; $i++) {
	  $newline = <MAINFILE>;
	  chop($newline);
	  @newfields = split /\s+/, $newline;
	  
	  $qmat[$i][0] = $newfields[0];
	  $qmat[$i][1] = $newfields[1];
	  $qmat[$i][2] = $newfields[2];
      }
  }
     
     if (($fields[0] eq "Transformation") && ($fields[3] eq "target")) {
       
       for ($i = 0; $i < 4; $i++) {
	 $newline = <MAINFILE>;
	 chop($newline);
	 @newfields = split /\s+/, $newline;
	 
	 $tmat[$i][0] = $newfields[0];
	 $tmat[$i][1] = $newfields[1];
	 $tmat[$i][2] = $newfields[2];
       }
     }
     
     if($fields[0] eq "Aligned") {
       
       $num = $fields[$#fields-1];
       $#query_aligned_SSEs = -1;
       $#target_aligned_SSEs = -1;
       for($i=0;$i<$num;$i++) {
	 $line2=<MAINFILE>;
	 chomp($line2);
	 @fields2 = split(/\s+/,$line2);
	 ($start,$end) = split(/,/,$fields2[1]);
	 $query_aligned_SSEs[$#query_aligned_SSEs+1][0] = $start;
	 $query_aligned_SSEs[$#query_aligned_SSEs][1] = $end;
	 $query_aligned_SSEs[$#query_aligned_SSEs][2] = $fields2[3];
	 $query_aligned_SSEs[$#query_aligned_SSEs][3] = $fields2[4];
	 ($start,$end) = split(/,/,$fields2[2]);
	 $target_aligned_SSEs[$#target_aligned_SSEs+1][0] = $start;
	 $target_aligned_SSEs[$#target_aligned_SSEs][1] = $end;
	 $target_aligned_SSEs[$#target_aligned_SSEs][2] = $fields2[3];
	 
       }
     }
     
     if($fields[0] eq "Num" && $fields[1] eq "Core" && $fields[2] eq "Aligned") {
       $num = $fields[$#fields];
       $#aligned_residues = -1;
       for($i=0;$i<$num;$i++) {
	 $line2 = <MAINFILE>;
	 chomp($line2);
	 ($num1, $aa1, $num2, $aa2,$dist) = split(/\s+/,$line2);
	 $aligned_residues[$#aligned_residues+1][0] = $num1;
	 $aligned_residues[$#aligned_residues][1] = $num2;
	 $aligned_residues[$#aligned_residues][2] = $dist;
       }
       
     }
     
     if($fields[0] eq "SSE") {
       $#target_helices = -1;
       $#target_strands = -1;
       $#query_helices = -1;
       $#query_strands = -1;
       $#target_SSEs = -1;
       $#query_SSEs = -1;
       <MAINFILE>; #discard line
       while(($line2 = <MAINFILE>) !~ /^target/) {
	 chomp($line2);
	 ($sstype,$start,$end) = split(/\s+/,$line2);
	 if($sstype eq "H") {
	   $query_helices[$#query_helices+1][0] = $start;
	   $query_helices[$#query_helices][1] = $end;
	 }else {
	   $query_strands[$#query_strands+1][0] = $start;
	   $query_strands[$#query_strands][1] = $end;
	 }
	 $query_SSEs[$#query_SSEs+1][0] = $start;
	 $query_SSEs[$#query_SSEs][1] = $end;
	 $query_SSEs[$#query_SSEs][2] = $sstype;
       }
       while(($line2 = <MAINFILE>) !~ /^CPU/) {
	 chomp($line2);
	 ($sstype,$start,$end) = split(/\s+/,$line2);
	 if($sstype eq "H") {
	   $target_helices[$#target_helices+1][0] = $start;
	   $target_helices[$#target_helices][1] = $end;
	 }else {
	   $target_strands[$#target_strands+1][0] = $start;
	   $target_strands[$#target_strands][1] = $end;
	 }
	 $target_SSEs[$#target_SSEs+1][0] = $start;
	 $target_SSEs[$#target_SSEs][1] = $end;
	 $target_SSEs[$#target_SSEs][2] = $sstype;
       }
     }
     
   }
   
   
   close(MAINFILE);
   if (-e $queryfile) {
       open(Qfile, "<$queryfile") || print STDERR "can't open $queryfile: $!\n";
   }else {
       
     system("/var/www/cgi-bin/FoldMiner2/findfile.pl",$queryfile,"$outputdir/tmpQ");
     
     open(Qfile, "<$outputdir/tmpQ") || print STDERR "can't open $outputdir/tmpQ: $!\n";
     
     if (not defined $querychain) {
       if($queryIsScop) {
	 $querychain = substr($shortqueryname,5,1);
	 if($querychain eq "_") {
	   $querychain = " ";
	 }
       }else {
	 ($querychain) = $shortqueryname =~ /^[1-9]...\-(.)/;
       }
     }
   }
   
   if (not defined $querychain) {
     $querychain = " ";
   }
   
   if (-e $targetfile) {
     open(Tfile, "<$targetfile");
   }
   else {
     system("/var/www/cgi-bin/FoldMiner2/findfile.pl",$targetfile,"$outputdir/tmpT");
     open(Tfile, "<$outputdir/tmpT");
     
     if (not defined $targetchain) {
       if($targetIsScop) {
	 $targetchain = substr($shorttargetname,5,1);
	 if($targetchain eq "_") {
	   $targetchain = " ";
	 }
       }else {
	    ($targetchain) = $shorttargetname =~ /^[1-9]...\-(.)/;
	  }
     }
   }
   
   if (not defined $targetchain) {
     $targetchain = " ";
   }
   $targetchain =~ tr/a-z/A-Z/;
   $querychain =~ tr/a-z/A-Z/;
   
   if (not -e "$outputdir/$outfile") { #don't make file again if it already exists!
     open (OUT, ">$outputdir/$outfile");
     
     print OUT "Content-type: text/plain\n\n";
    
#I'm not sure setupChainInfo is actually needed, though it may be necessary if we need to keep track of the original chains in the query and target before assigning query to chain A and target to chain B
  #    setupChainInfo(0, \%queryTable);
  #    setupChainInfo(1, \%targetTable);
    
     printHELIXInfo($querychain, *Qfile, "A",\@query_helices);
     printHELIXInfo($targetchain, *Tfile, "B",\@target_helices);
     
     printSHEETInfo($querychain, *Qfile, "A",\@query_strands);
     printSHEETInfo($targetchain, *Tfile, "B",\@target_strands);
     
     printATOMInfo($querychain, *Qfile, "A");
     printATOMInfo($targetchain, *Tfile, "B");
     
     print OUT "END    \n";
     
     close(OUT);
     close(Qfile);
     close(Tfile);
     
     if (-e "$outputdir/tmpQ") {
       system("$rm","-f","$outputdir/tmpQ");
     }
     if (-e "$outputdir/tmpT") {
       system("$rm","-f","$outputdir/tmpT");
     }
     
   }
   
if ($chime == 1) { #print out chime display
    $tmpfile = "$outputdir/tmp.html";
    open(chimefile,">$tmpfile");
    print chimefile  <<END;
<html>
<head>
<link rel=stylesheet href="/FoldMiner2/lock.css" type="text/css">
<meta http-equiv="no-cache">
<meta http-equiv=description name=description 
content="LOCK, output">
<meta http-equiv=keywords name=keywords 
content="hierarchical protein structure superposition, bioinformatics, LOCK, biochemistry">

<title>LOCK 2: Hierarchical Protein Structure Superposition</title>
<script language="Javascript" type="text/javascript">
  function launchHelpWindow(anchor) {
   var URL = "/FoldMiner/help.html#"+anchor;
   var mywin=window.open('','help',"directories=no,location=no,menubar=no,scrollbars=yes,toolbar=no,resizable=yes,status=yes,width=350,height=300");
   mywin.location.replace(URL);
    mywin.focus();
  }     


  function executeChimeScript(str) {
     var newstr = str
     var re = /query/ig;
     newstr=newstr.replace(re,"*A")
     re = /target/ig;
     newstr=newstr.replace(re,"*B")
     with (top.invisible.document) {
       open();
       writeln("<html><head></head><body bgcolor=white>");
       writeln("<embed type=\\\"application\/x-spt\\\" hidden=true");
       writeln("width=10 height=10 button=push target=\\\"alignment\\\"");
       writeln("script=\\\""+newstr+"\\\" immediate=1");
       writeln("</body></html>");
       close();
     }
  }
</script>
</head>

<body bgcolor=#FFFFFF link=#26246b alink=#8777bab vlink=#8777bab>
<!--LOCK 2 header -->
<p>
<table width=100% cellpadding=0 cellspacing=0 border=0>

<tr><td align=left><a href=/FoldMiner2/?lock target=_top><img align=left src=/FoldMiner2/images/lock2.gif border=0></a></td>

<td align=right>
<br><a href="mailto:jessicas\@stanford.edu" >Jessica Shapiro</a>
<br><a href=http://gene.stanford.edu/~apsingh target=_top>Amit P. Singh</a>
<br><a href=//cmgm.stanford.edu/~brutlag target=_top>Douglas L. Brutlag</a>
<br><a href=http://motif.stanford.edu target=_top>Bioinformatics Group</a>
<br><a href=//www.stanford.edu/ target=_top>Stanford University</a>
</td>
</tr>
</table></p>
<br>

END
$defaultscript = "select all\ncartoons\ncolor chain\n";
print chimefile "<form name=\"commandline\">\n";
print chimefile "<table border =0 rows=1>\n";
print chimefile "<tr>\n";
print chimefile "<td  width=\"50%\" align=left><font size=+1><span class=\"queryAlignmentInfo\">Query: $shortqueryname</span></font></td>\n";
print chimefile "<td  width=\"50%\" align=left><font size=+1><span class=\"targetAlignmentInfo\">Target: $shorttargetname</span></font></td>\n";

print chimefile "</tr></table>\n";
print chimefile "<table border=0 width=\"650\">\n";

print chimefile "<tr> <!--chime options and display go in this row; display covers many rows-->\n";
print chimefile "    <td valign=top width=\"200\"><table border=0><!--chime option table-->\n";
print chimefile "        <tr><td colspan=2 bgcolor=#bbbbbb width=\"100%\"><span class=\"chimeOptionHeader\">Structural Alignment and Motif Options</span></td></tr>" ;
print chimefile "        <tr><td colspan=2 bgcolor=#e5e5e5 width=\"100%\"><span class=\"chimeOptionSubHeader\">Show me:</span></td></tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Aligned Secondary Structure Elements</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select all\ncolor chain\n";
($queryselect,$targetselect) = &getAlignedSSEs();
print chimefile "select all\ncolor gray\n";
if($queryselect ne "") {
    print chimefile "select $queryselect\n";
    print chimefile "color chain\n";
    print chimefile "select $targetselect\n";
    print chimefile "color chain\n";
}
print chimefile "select all\n";
print chimefile "\">\n";
#print chimefile "altscript=\"$defaultscript\">\n";
print chimefile "            </td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor = #f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Aligned Residues</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\ndebugscript=true\nscript=\"select all\ncolor gray\n";
#($queryselect, $targetselect) = &getAlignedResidues();
for($i=0;$i<=$#aligned_residues;$i++) {
  print chimefile "select $aligned_residues[$i][0]A;color chain;select $aligned_residues[$i][1]B;color chain\n";
}

#print chimefile "select $queryselect;\n";
#print chimefile "color cyan;\n";
#print chimefile "select $targetselect;\n";
#print chimefile "color magenta;\n";
print chimefile "select all\">\n";
#print chimefile "altscript=\"$defaultscript\">\n";
print chimefile "           </td>\n";
print chimefile "        </tr>\n";
if($motif) {
  print chimefile "        <tr bgcolor=#f6f6f6>\n";
  print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\"><font color=blue>Query's</font> motif/core fold</span></td>\n";
  print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select all\ncolor monochrome\n";
  $script = getQueryConservationScript($filenum);
  print chimefile "$script; select all\n\">\n";
  print chimefile "            </td>\n";
  print chimefile "        </tr>\n";
}
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Secondary structure element alignment scores</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"";
$script2 = getAlignmentScoresScript();
print chimefile "$script2;select all\n\">\n";
print chimefile "            </td>\n";
print chimefile "        </tr>\n";
#select options
print chimefile "        <tr><td colspan=2 bgcolor=#bbbbbb width=\"100%\"><span class=\"chimeOptionHeader\">Residue Selection Options</span></td></tr>" ;
print chimefile "        <tr><td colspan=2 bgcolor=#e5e5e5 width=\"100%\"><span class=\"chimeOptionSubHeader\">Select all residues in:</span></td></tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\"><font color=blue>Query</font></span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select *A\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\"><font color=red>Target</font></span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select *B\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\"><font color=blue>Query</font> and <font color=red>Target</font></span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\nbuttonstate=\"pushed\"\ntarget=\"alignment\"\nscript=\"select all\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
#could do query strands and target strands separately
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\">Strands</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select sheet\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\">Helices</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select helix\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\">Ligands</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select ligands\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\">Water</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select water\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=\"88%\"><span class=\"chimeOption\">Other solvents</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"select ions\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr><td colspan=2 bgcolor=#e5e5e5 width=\"100%\"><span class=\"chimeOptionSubHeader\">Select aligned:</span></td></tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Query Residues</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"\n";
($querystring,$targetstring) = getAlignedResidues();
print chimefile "select ($querystring)";
print chimefile "             \"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Target Residues</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"\n";
print chimefile "select ($targetstring)";

print chimefile "             \"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Query and Target Residues</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"\n";
print chimefile "select ($querystring) or ($targetstring)";

print chimefile "             \"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Query secondary structure elements</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"";
($queryselect,$targetselect) = &getAlignedSSEs();
print chimefile "select $queryselect\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Target secondary structure elements</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"";
print chimefile "select $targetselect\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td  width=\"88%\"><span class=\"chimeOption\">Query and target secondary structure elements</span></td>\n";
print chimefile "            <td align=right width=\"12%\"><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=radio1\ntarget=\"alignment\"\nscript=\"";
print chimefile "select $queryselect or $targetselect\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        </tr></td>\n"; #end row and cell of outer chime options table
print chimefile "    </table></td>\n"; #end of chime options table
print chimefile "<td align=center valign=top width=\"300\">\n";
print chimefile "   <table border=0 rows=4 cols=2> <!--chime display and command line-->\n";
print chimefile "       <tr>\n";
print chimefile "           <td colspan=2 align=center valign=top><embed src=$wwwoutput/$outfile
bgcolor=#FFFFFF
width=300
height=300
debugscript=\"yes\"
frank=\"no\"
color3d=chain
display3d=cartoons
name=\"alignment\"\n";
if($motif) {
  print chimefile "script=\"$defaultscript; select all\"";
}else {
  print chimefile "script=\"$defaultscript; select all\"";
}
print chimefile "                  ></td></tr>\n";
print chimefile <<END;
<tr>
<td colspan=2>
   <table border=0 width="100%" cellspacing=3>
    <tr>

     <td>Translate:</td>
     <td><table border=0><tr><td><input type=button name=left value="&larr;" onClick="javascript:executeChimeScript('move 0 0 0 0 -3 0 0 0 0')"></td><td>x</td><td><input type=button name=right value="&rarr;" onClick="javascript:executeChimeScript('move 0 0 0 0 3 0 0 0 0')"></td></tr></table></td>
     <td><table border=0><tr><td><input type=button name=up value="&uarr;" onClick="javascript:executeChimeScript('move 0 0 0 0 0 -3 0 0 0')"></td><td>y</td><td><input type=button name=down value="&darr;" onClick="javascript:executeChimeScript('move 0 0 0 0 0 3 0 0 0')"></td></tr></table></td>

<td><input type=button name="resetview" value="Reset View" onClick="javascript:executeChimeScript('reset')"></td>
    </tr>
    </table>
</td>
</tr>
END
print chimefile "           <tr height=\"20%\"><td colspan=2>Enter a <a href=\"javascript:launchHelpWindow(\'chimescript\')\" onMouseOver=\"status='Click for help'\" onMouseOut=\"status=''\" class=\"helplink\">chime script</a> (separate commands with carriage returns or semicolons) and press \"Execute\":</td></tr>\n";
print chimefile "           <tr height=\"40%\">\n";
print chimefile "               <td rowspan=2 align=right><textarea name=\"rasmolcommand\" rows=3 cols=40 value=\"\"></textarea></td>\n";
#print chimefile "               <td align=center valign=center><input type=button name=sendscript value=\"Execute\" onClick=\"document.alignment.executeChimeScript(document.commandline.rasmolcommand.value)\"></td>\n";
  print chimefile "                <td align=left valign=center><input type=button name=sendscript value=\"Execute\" onClick=\"javascript:executeChimeScript(document.commandline.rasmolcommand.value)\"></td>\n";
print chimefile "               <tr height=\"40%\"><td align=left valign=center><input type=button name=resetscript value=\"Clear\" onClick=\"document.commandline.rasmolcommand.value='';\"></td>\n";
print chimefile "          </tr>\n";
print chimefile "          <tr><td><font size=-1>Use the words 'query' and 'target' to refer to residues in the query and target structures (i.e. 'select query' selects all residues in the query structure).</font></td></tr>\n";
print chimefile "       </table>\n";
#put more chime options on the other side BACKGROUND COLORS ARE WRONG!
print chimefile "<td valign=top width=\"150\">\n";
print chimefile "<table border=0 cols=4 cellpadding=1> <!--more chime options: color and display-->\n";
print chimefile "        <tr><td colspan=4 bgcolor=#bbbbbb><span class=\"chimeOptionHeader\">Color Options</span></td></tr>" ;
print chimefile "        <tr><td colspan=4 bgcolor=#e5e5e5><span class=\"chimeOptionSubHeader\">Color selected residues:</span></td></tr>\n";
print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td width=10%><span class=\"chimeOption\">Blue</span></td><td align=left width=20%><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color blue\"></td>\n";
print chimefile "            <td width=10%><span class=\"chimeOption\">&nbsp;&nbsp;Red</span></td><td align=left width=60%><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color red\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td><span class=\"chimeOption\">Cyan</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color cyan\"></td>\n";
print chimefile "            <td><span class=\"chimeOption\">&nbsp;&nbsp;Magenta</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color magenta\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td><span class=\"chimeOption\">Green</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color green\"></td>\n";
print chimefile "            <td><span class=\"chimeOption\">&nbsp;&nbsp;Yellow</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color yellow\"></td>\n";
print chimefile "        </tr>\n";

print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td><span class=\"chimeOption\">Purple</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color purple\"></td>\n";
print chimefile "            <td><span class=\"chimeOption\">&nbsp;&nbsp;Gray</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color gray\"></td>\n";
print chimefile "        </tr>\n";

print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "             <td><span class=\"chimeOption\">&nbsp;&nbsp;CPK</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color cpk\"></td>\n";
print chimefile "             <td><span class=\"chimeOption\">&nbsp;&nbsp;Temperature</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color temperature\"></td>\n";
print chimefile "         </tr>\n";

print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td><span class=\"chimeOption\">Default</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color chain\"></td>\n";
print chimefile "            <td><span class=\"chimeOption\">&nbsp;&nbsp;By 2<sup>o</sup><br>&nbsp;&nbsp;structure</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"color structure\"></td>\n";
print chimefile "        </tr>\n";

print chimefile "        <tr><td colspan=4 bgcolor=#bbbbbb><span class=\"chimeOptionHeader\">Display Options</span></td></tr>" ;
print chimefile "        <tr><td colspan=4 bgcolor=#e5e5e5><span class=\"chimeOptionSubHeader\">Display selection in:</span></td></tr>\n";
#display buttons used to be of type radio3; changed to push
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td width=45%><span class=\"chimeOption\">Cartoons</span></td><td align=left width=5%><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"cartoons on; backbone off; wireframe off; dots off;  spacefill off\"></td>\n";
print chimefile "            <td width=45%><span class=\"chimeOption\">&nbsp;&nbsp;Backbone</span></td><td align=left width=5%><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"backbone 100; wireframe off; cartoons off; dots off; ribbons off; spacefill off\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td><span class=\"chimeOption\">Spacefill</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"cartoons off; backbone off; wireframe off; dots off;  spacefill on\"></td>\n";
print chimefile "            <td><span class=\"chimeOption\">&nbsp;&nbsp;Wireframe</span></td><td align=left><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"backbone off; wireframe on; cartoons off; dots off; ribbons off; spacefill off\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr><td colspan=4 bgcolor=#bbbbbb width=\"100%\"><span class=\"chimeOptionHeader\">Heteroatom Display Options</span></td></tr>" ;
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">Ligands</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=toggle\ntarget=\"alignment\"\nscript=\"select ligands; wireframe on; color cpk\"\naltscript=\"select ligands; wireframe off\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">Water</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=toggle\ntarget=\"alignment\"\nscript=\"select water; spacefill 50\"\naltscript=\"select water; spacefill off\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">Other solvents</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=toggle\ntarget=\"alignment\"\nscript=\"select ions; spacefill 50\"\naltscript=\"select ions; spacefill off\"></td>\n";
print chimefile "        </tr>\n";

print chimefile "        <tr><td colspan=4 bgcolor=#bbbbbb><span class=\"chimeOptionHeader\">Other Options</span></td></tr>" ;
print chimefile "        <tr><td colspan=4 bgcolor=#e5e5e5><span class=\"chimeOptionSubHeader\">Labels:</span></td></tr>\n";
print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">Off</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"label off\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr><td colspan=4 bgcolor=#e5e5e5><span class=\"chimeOptionSubHeader\">Background:</span></td></tr>\n";
print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">Black</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"background black\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "        <tr  bgcolor=#f6f6f6>\n";
print chimefile "            <td colspan=3><span class=\"chimeOption\">White</span></td>\n";
print chimefile "            <td align=center><embed type=\"application/x-spt\"\nwidth=12\nheight=12\nbutton=push\ntarget=\"alignment\"\nscript=\"background white\"></td>\n";
print chimefile "        </tr>\n";
print chimefile "</table>\n";
print chimefile "</td>\n";

print chimefile "</tr>\n</table>\n"; #end of outer table for chime options and display

print chimefile "</form>\n";
print chimefile "</body>\n";
print chimefile "</html>\n";
close(chimefile);

  open(buttonframe,">$outputdir/button.html");
  print buttonframe <<END;
<html><head></head><body bgcolor=white>
<embed type="application/x-spt" hidden=true
width=10;
height=10;
button=push
target="alignment"
script="select all\ncolor purple\n";
immediate=1>
</body>
</html>
END
close(buttonframe);
  print "Content-type: text/html\n";
  print "Cache-control: no-cache\n\n";
  print <<END;
<html>
<head>
<title>LOCK 2 Alignment Viewer</title>
<script language="Javascript" type="text/javascript">

function loadAlignment() {
   viewer.location.reload(true)
}   

</script>
</head>
<frameset rows="100%,0" border=0 onLoad="javascript:loadAlignment()">
  <frame src="$wwwoutput/tmp.html" name="viewer">
  <frame src="/FoldMiner/empty.html" name="invisible" scrolling="no">
</frameset>
</html>
END
}

else {
  open(FILE, "$outputdir/$outfile");
  while($line = <FILE>) {
    print $line;
  }

}

exit(0);

######################################################################


sub printHELIXInfo() {
  my($mychain, $myPtr, $myoutchain, $helixref) = @_;
  my($i,$start,$end,$string,$temp);

  for($i=0;$i<=$#$helixref;$i++) {
    $start = $$helixref[$i][0];
    $end = $$helixref[$i][1];
    $string = " " x 76;
    substr($string,0,6) = "HELIX ";
    $temp = sprintf("%4d",$start);
    substr($string,21,4) = $temp;
    $temp = sprintf("%4d",$end);
    substr($string,33,4) = $temp;
    substr($string,19,1) = $myoutchain;
    substr($string,31,1) = $myoutchain;
    $string.="\n";
    print OUT $string;
  }
}

sub printSHEETInfo() {
  my($mychain, $myPtr, $myoutchain, $strandref) = @_;
  my($i,$start,$end,$string,$temp);

  for($i=0;$i<=$#$strandref;$i++) {
    $start = $$strandref[$i][0];
    $end = $$strandref[$i][1];
    $string = " " x 70;
    substr($string,0,6) = "SHEET ";
    $temp = sprintf("%4d",$start);
    substr($string,22,4) = $temp;
    $temp = sprintf("%4d",$end);
    substr($string,33,4) = $temp;
    substr($string,21,1) = $myoutchain;
    substr($string,32,1) = $myoutchain;
    $string.="\n";
    print OUT $string;
  }

}

sub printATOMInfo {
  my($mychain, $myPtr, $myoutchain) = @_;
  my($line,$done,$dssp);

  seek($myPtr,0,0);
  $line = <$myPtr>;
  if(substr($line,51,4) eq "DSSP") {
    $dssp = 1;
  }elsif($line =~/^HEADER/) {
    $dssp = 0;
  }
  $done = 0;
  
  if(!$dssp) {
    while(($line = <$myPtr>) && !$done) {
      ($record) = $line =~/^(......)/;
      if($record eq "ATOM  " || $record eq "HETATM") {
	$linechain = substr($line,21,1);
	if(($mychain eq " ") || ($linechain eq $mychain)) {
	  $mynum = substr($line,22,4); #Amit changed this: maybe to deal with multiple chains?
	  $temp = sprintf("%4d",$mynum);
	  substr($line,22,4) = $temp;
	  substr($line,21,1) = $myoutchain;
	  
	  $myvec[0] = substr($line,30,8);
	  $myvec[1] = substr($line,38,8);
	  $myvec[2] = substr($line,46,8);
	  if (($myvec[0] ne "") && ($myvec[1] ne "") && ($myvec[2] ne "")) {
	    if ($myoutchain eq "A") {
	      applyMatToVect(\@qmat, \@myvec);
	      
	    }else {
	      applyMatToVect(\@tmat, \@myvec);
	    }
	    $temp = sprintf "%8.3f", $myvec[0];
	    substr($line, 30, 8) = $temp;
	    $temp = sprintf "%8.3f", $myvec[1];
	    substr($line, 38, 8) = $temp;
	    $temp = sprintf "%8.3f", $myvec[2];
	    substr($line, 46, 8) = $temp;

	  }
	  print OUT $line;
	}
      }elsif($record eq "ENDMDL") {
	$done = 1;
      }elsif($record eq "END   ") {
	$done = 1;
      }
      
    }
  
  }else { #dealing with dssp file
    while(!$done && (($line=<$myPtr>) !~ /^..\#..........AA...........BP1/)) {}
    $XX = -1;
    if(substr($line,118,1) eq "X") {
      $XX = 116; $YY = 123; $ZZ = 130;
    }elsif(substr($line,110,1) eq "X") {
      $XX = 108; $YY=115; $ZZ=122;
    }else {
      for($i=0;$i<190;$i++) {
	if($line =~/^.{$i}X\-CA/) {
	  $XX=$i-2; $YY = $XX+7; $ZZ = $YY+7;
	  last;
	}
      }
    }
    if($XX == -1 || $done) {
      return;
    }
    $count = 0;
    while(!$done && ($line=<$myPtr>)) {
      $linechain = substr($line,11,1);
      $newline = " " x 80;
      if(($mychain eq " ") || ($linechain eq $mychain)) {
	if(substr($line,13,1) ne "!") {
	  $count++;
	  substr($newline,0,6) = "ATOM  ";
	  substr($newline,21,1) = $myoutchain;      #chain identifier
	  $mynum = substr($line,5,5);
	  $temp = sprintf("%4d",$mynum);
	  substr($newline,22,4) = $temp;  #residue number
	  substr($newline,6,5) = sprintf("%5d",$count); #atom serial number
	  substr($newline,12,4) = " CA ";               #residue type (only alpha carbons available)
	  substr($newline,17,3) = $aacodes{substr($line,13,1)};  #residue name
	}
      }
      chomp($line);
      $myvec[0] = substr($line,$XX,7);
      $myvec[1] = substr($line,$YY,7);
      $myvec[2] = substr($line,$ZZ, 7);

      if (($myvec[0] ne "") && ($myvec[1] ne "") && ($myvec[2] ne "")) {
	if ($myoutchain eq "A") {
	  applyMatToVect(\@qmat, \@myvec);
	}else {
	  applyMatToVect(\@tmat, \@myvec);

	}	
	$temp = sprintf "%8.3f", $myvec[0];
	substr($newline, 30, 8) = $temp;
	$temp = sprintf "%8.3f", $myvec[1];
	substr($newline, 38, 8) = $temp;
	$temp = sprintf "%8.3f", $myvec[2];
	substr($newline,46 , 8) = $temp;
	substr($newline,54,6) = sprintf("%6.2f",1.0); #occupancy
	substr($newline,60,6) = sprintf("%6.2f",0.0); #temperature factor
	if($myoutchain eq "A") {
	  substr($newline,72,4) = $querypdbid;
	}else {
	  substr($newline,72,4) = $targetpdbid;
	}
	substr($newline,76,2) = sprintf("%2s","C");
	$newline .= "\n"
      }

      print OUT $newline;
    }
  }
  
}


sub applyMatToVect() {

    $t[0] = $_[1][0] * $_[0][0][0] + $_[1][1] * $_[0][1][0] + $_[1][2] * $_[0][2][0] + $_[0][3][0];
    $t[1] = $_[1][0] * $_[0][0][1] + $_[1][1] * $_[0][1][1] + $_[1][2] * $_[0][2][1] + $_[0][3][1];
    $t[2] = $_[1][0] * $_[0][0][2] + $_[1][1] * $_[0][1][2] + $_[1][2] * $_[0][2][2] + $_[0][3][2];
    $temp = $_[1][0]*$_[0][0][0];

    $_[1][0] = $t[0];
    $_[1][1] = $t[1];
    $_[1][2] = $t[2];

}


sub getAlignedSSEs {
  my($i);
  my($query,$target);

 if($#query_aligned_SSEs > -1) {
    $query=$query_aligned_SSEs[0][0]."-".$query_aligned_SSEs[0][1]."A";
    $target=$target_aligned_SSEs[0][0]."-".$target_aligned_SSEs[0][1]."B";
    
    for($i=1;$i<=$#query_aligned_SSEs;$i++) {
      $query .= ",$query_aligned_SSEs[$i][0]-$query_aligned_SSEs[$i][1]A";
      $target .= ",$target_aligned_SSEs[$i][0]-$target_aligned_SSEs[$i][1]B";
    }
    
    return(($query,$target));
  }else {
    return(("",""));
  }
  
}

sub getAlignedResidues {
  my($i,$query,$target);

  $query="($aligned_residues[0][0]";
  $target = "($aligned_residues[0][1]";
  for($i=1;$i<$#aligned_residues;$i++) {
    $query .= ",$aligned_residues[$i][0]";
    $target .=",$aligned_residues[$i][1]";
  }
  $query .= ") and *A";
  $target .= ") and *B";
  return(($query,$target));
}

sub getAlignmentScoresScript {
  my($string,$i, $score);
  my($r,$g,$b);
  my($h1, $h2, $s, $v, $ratio);
  $h1 = 240; #blue
  $h2 = 0; #red
  $s = 100;
  $ratio = (100/20)**(1/19); #ratio 

  $string = "select all; color gray; ";
  for($i=0;$i<=$#query_aligned_SSEs;$i++) {
    if($query_aligned_SSEs[$i][3] > 0) {
	$score = $query_aligned_SSEs[$i][2]/$query_aligned_SSEs[$i][3]; #normalize the score
    }else {
	$score = 0;
    }
    ($r, $g, $b) = getColorByConservation($h1, $s, $score, $ratio);

    $string .= "select $query_aligned_SSEs[$i][0]-$query_aligned_SSEs[$i][1]A; color [$r, $g, $b]; ";
    ($r, $g, $b) = getColorByConservation($h2, $s, $score, $ratio);
    $string .= "select $target_aligned_SSEs[$i][0]-$target_aligned_SSEs[$i][1]B; color [$r, $g, $b]; ";
    $len1 = int(($query_aligned_SSEs[$i][1]-$query_aligned_SSEs[$i][0])/2);
    $len2 = int(($target_aligned_SSEs[$i][1]-$target_aligned_SSEs[$i][0])/2);
    $score = (int($score*100))/100;
    if($len1 > $len2) {
      $middle = $len1+$query_aligned_SSEs[$i][0];
      $string .= "set fontsize 7; select ($middle and *A and *.CA and not hetero); label $score; color label black; ";
    }else {
      $middle = $len2+$target_aligned_SSEs[$i][0];
      $string .= "set fontsize 7; select ($middle and *A and *.CA and not hetero); label $score; color label black; ";
    }
  }
  $string = substr($string,0,length($string)-1);
  return($string);
}

sub getColorByConservation {
  my($hue, $sat, $conservation, $ratio) = @_;
  my($r,$g,$b);
  
  if($conservation < 0.05) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**0));
    }elsif($conservation < 0.1) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**1));
    }elsif($conservation < 0.15) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**2));
    }elsif($conservation < 0.2) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**3));
    }elsif($conservation < 0.25) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**4));
    }elsif($conservation < 0.3) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**5));
    }elsif($conservation < 0.35) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**6));

    }elsif($conservation < 0.4) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**7));
    }elsif($conservation < 0.45) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**8));
    }elsif($conservation < 0.5) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**9));
    }elsif($conservation < 0.55) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**10));
    }elsif($conservation < 0.6) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**11));
    }elsif($conservation < 0.65) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**12));
    }elsif($conservation < 0.7) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**13));
    }elsif($conservation < 0.75) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**14));
    }elsif($conservation < 0.8) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**15));
    }elsif($conservation < 0.85) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**16));
    }elsif($conservation < 0.9) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**17));
    }elsif($conservation < 0.95) {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**18));
    }else {
      ($r, $g, $b) = HSVtoRGB($hue, $sat, 20*($ratio**19));
    }
  return($r,$g,$b);
}

sub getQueryConservationScript {
  my($filenum) = @_;
  my($string, $i, $line);
  my($file);
  my(@starts,@ends,@conservations, $dummy);
  my(@color, $ratio);
  my(%excluded);

  %excluded = ();
  $ratio = (100/20)**(1/19);
  $#starts = $#ends = $#conservations = -1;

  $file = sprintf("%s/profile%s",$outputdir,$filenum);

  open(PROFILE, $file) || print STDERR "can't open $file: $!\n";
  while($line = <PROFILE>) {
    ($starts[$#starts+1],$ends[$#ends+1],$conservations[$#conservations+1],$dummy) = split(/\s+/,$line);
    if($conservations[$#conservations] == 0) {
      $excluded{$starts[$#starts]} = 1;
    }      
  }
  close(PROFILE);

  #first, color the query in gray and the target in a light blue
  $string = "select all; color gray;  ";
  $jstart = 0;
  for($i=0;$i<=$#starts;$i++) {
    $string .= "select ($starts[$i]-$ends[$i]A and not hetero); ";
    ($r,$g,$b) = getColorByConservation(240,100,$conservations[$i],$ratio);
    $string .= "color [$r, $g, $b]; ";
    for($j=$jstart;$j<=$#target_aligned_SSEs;$j++) {
      if($query_aligned_SSEs[$j][0] eq $starts[$i]) {
	$string .= "select ($target_aligned_SSEs[$j][0]-$target_aligned_SSEs[$j][1]B and not hetero); ";    
	($r,$g,$b) = getColorByConservation(0,100,$conservations[$i],$ratio);
	$string .= "color [$r,$g,$b]; ";
	$jstart = $j;
	last;
      }
    }
  }


  
  return($string);
}

#for now, positioning of SSE options will not reflect actual alignment
sub getSSECheckboxes() {
  my($string);
  my($numrows,$i);
  my($numquery, $numtarget);

  if($#target_SSEs > $#query_SSEs) {
    $numrows = $#target_SSEs+1;
  }else {
    $numrows = $#query_SSEs+1;
  }
  $numquery = $#query_SSEs +1;
  $numtarget = $#target_SSEs+1;

  $string = "";
  for($i=0;$i<$numrows;$i++) {
    $string .="<tr>\n";
    if($i<$numquery) {
      $string .= "<td ";
    }else {

    }
    if($i<$numtarget) {

    }else {

    }
    $string.="\n</tr>\n";
  }
}


#Given the conservation of an SSE, returns a color in rgb format. High conservations
#correspond to bright colors. The color scheme was developed in HSV colorspace with the
#brightest color corresponding to (353,95,80) and the darkest to (353,95,10). 
#Photoshop was used for RGB conversions. Colors are not necessarily "web safe," but
#should print on most printers.
sub getColor {
  my($c) = @_; #conservation

  if($c < 0.05) {
    return((26,1,4));
  }elsif($c < 0.1) {
    return((28,1,5));
  }elsif($c < 0.15) {
    return((31,2,5));
  }elsif($c < 0.2) {
    return((36,2,6));
  }elsif($c < 0.25) {
    return((38,2,6));
  }elsif($c < 0.3) {
    return((43,2,7));
  }elsif($c < 0.35) {
    return((48,2,8));
  }elsif($c < 0.4) {
    return((56,3,9));
  }elsif($c < 0.45) {
    return((61,3,10));
  }elsif($c < 0.5) {
    return((69,3,11));
  }elsif($c < 0.55) {
    return((77,4,12));
  }elsif($c < 0.6) {
    return((84,4,14));
  }elsif($c < 0.65) {
    return((94,5,15));
  }elsif($c < 0.7) {
    return((102,5,16));
  }elsif($c < 0.75) {
    return((117,6,19));
  }elsif($c < 0.8) {
    return((133,7,21));
  }elsif($c < 0.85) {
    return((148,7,24));
  }elsif($c < 0.9) {
    return((184,9,30));
  }else {
    return((204,10,33));
  }

}

#convert an hsv color specification to rgb
sub HSVtoRGB {
  my($hue, $sat, $value) = @_;
  my($r,$g,$b);
  my($i, $f, $p, $q, $t);


  #$sat and $value should lie on the range [0,1]
  $sat /= 100;
  $value /= 100;
  if($sat == 0) {
    $r = $g = $b = ($value*255);
  }else {
    if($hue == 360) { $hue = 0;}
    $hue/=60.0;
    $i = int($hue); #integer part of $floathue
    $f = $hue - $i; #fractional part of $floathue

    $p = $value * (1.0-$sat);
    $q = $value * (1.0 - ($sat*$f));
    $t = $value * (1.0 - ($sat*(1.0-$f)));

    if($i==0) {
      $r = $value * 255;
      $g = $t*255;
      $b = $p*255;
    }elsif($i==1) {
      $r = $q * 255;
      $g = $value*255;
      $b = $p*255;
    }elsif($i==2) {
      $r = $p *255;
      $g = $value*255;
      $b = $t*255;
    }elsif($i==3) {
      $r = $p*255;
      $g = $q*255;
      $b = $value*255;
    }elsif($i==4) {
      $r = $t*255;
      $g = $p*255;
      $b = $value*255;
    }elsif($i==5) {
      $r = $value*255;
      $g = $p*255;
      $b = $q*255;
    }
    
  }
  #round the numbers
  $r = int($r+0.5);
  $g = int($g+0.5);
  $b = int($b+0.5);
  return($r,$g,$b);
}

sub redirectToErrorHandler {
  my($input,$error,$correctinput,$helptopic,$pid) = @_;
  my($email) = "jessicas\@stanford.edu";
  my($name) = "Jessica Ebert";

  $input=CGI::escape($input);
  $error = CGI::escape($error);
  $correctinput=CGI::escape($correctinput);
  $helptopic=CGI::escape($helptopic);
  $email=CGI::escape($email);
  $name=CGI::escape($name);


  print "Cache-control: no-cache\n";
  print "Content-type: text/html\n\n";
  print <<END;
<html>
<head>
<meta http-equiv="Pragma" content='no-cache'>
<meta http-equiv="refresh" content="0;URL=/cgi-bin/FoldMiner2/reporterror.cgi?error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsidr=$pid">
<title>LOCK 2: Error</title>
</head>
<body>
An error occurred. If you are not automatically redirected in two seconds, <a href="/cgi-bin/FoldMiner2/reporterror.cgi?error=$error&exampleinput=$correctinput&input=$input&email=$email&name=$name&helptopic=$helptopic&resultsdir=$pid">click here.</a>
</body>
</html>
END

}
